//---- input parameters
 extern bool trade = true;
 extern int slo = 3;
 extern int fast = 1;
 extern int sl = 60;
 extern int ts = 40;
 extern int tp = 500;
 extern int elevation = 3;
 extern int slippage = 5;
 extern double minp = 0;
 extern double lots = 0.1;
 extern bool constant_lot = true;
 extern double maxrisk = 0.1;
 extern int Magic = 777;
//
int start()
{
  if(!trade) return(0);
   if(Bars<100)   {Print("bars less than 100"); return(0);}
   if(!IsTradeAllowed()) {Sleep(120000); return(0);}
//
   for(int i = OrdersTotal(); i >= 0; i--)
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol()==Symbol() && OrderMagicNumber()== Magic) 
         {
           if(OrderType() == OP_BUY)  // long position is opened
            {
               if((OrderOpenPrice()-Ask)<Point*sl) // stoploss
                 {
                    OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Aqua);
                    return(0);
                 }
               if(detect()==-1) //close by sell condition
                 {
                    OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Lime);
                    return(0);
                 }
               if((Bid-OrderOpenPrice())>Point*(ts+minp)) //trail
                 {
                  if(OrderStopLoss()<(Bid-Point*ts))
                   {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*ts,OrderTakeProfit(),0,Orange);
                    return(0);
                   }
                 }
            } 
           if(OrderType() == OP_SELL)  // short position is opened
            {
               if((Bid-OrderOpenPrice())>Point*sl) // stoploss
                 {
                    OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Magenta);
                    return(0);
                 }
               if(detect()==1) //close by buy condition
                 {
                    OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Crimson);
                    return(0);
                 }
               if((OrderOpenPrice()-Ask)>Point*(ts+minp)) //trail
                {
                 if(OrderStopLoss()>(Ask+Point*ts))
                  {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*ts,OrderTakeProfit(),0,Orange);
                    return(0);
                  }
                }
            }
         return(0);
        }
     }
//new order
   if(detect()==1 && CalculateOrders()==0)
     {
      OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,slippage,0,Ask+tp*Point,WindowExpertName(),Magic,0,Green);
     }
   if(detect()==-1 && CalculateOrders()==0)
     {
      OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,slippage,0,Bid-tp*Point,WindowExpertName(),Magic,0,Red);
     }
//
return(0);
}
//
int CalculateOrders()
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//
double detect()
{
   RefreshRates();                             
//Free margin check
   double lotcost = MarketInfo(Symbol(),MODE_MARGINREQUIRED);//  1 
    if(AccountFreeMargin()<LotsOptimized()*lotcost) 
      {
         Print("Not enough funds, free margin = ", AccountFreeMargin());
         return(0);
      }
//
     double lpf0 = iMA(Symbol(),0,slo,0,MODE_SMA,PRICE_CLOSE,0);
     double lpf1 = iMA(Symbol(),0,slo,0,MODE_SMA,PRICE_CLOSE,1);
     //double hpf0 = iMA(Symbol(),0,fast,0,MODE_SMA,PRICE_CLOSE,0);
     //double hpf1 = iMA(Symbol(),0,fast,0,MODE_SMA,PRICE_CLOSE,1);
//
   if(Close[1]<lpf1 && (Close[0]-elevation*Point)>lpf0) return(1);
   if(Close[1]>lpf1 && (Close[0]+elevation*Point)<lpf0) return(-1);
}
//
double LotsOptimized()
{
   RefreshRates();                             
   double lot = lots;
   double minlot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   double lotstep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double lotcost = MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   if(!constant_lot)
    {
      lot = NormalizeDouble((AccountFreeMargin()*maxrisk)/lotcost,2);
      lot = lotstep*(MathRound(lot/lotstep));
      if(AccountFreeMargin()<lot*lotcost) lot = minlot;
      if(lot<minlot) lot = minlot;
      if(lot>maxlot) lot = maxlot;
      return(lot);
    } 
   else
    {
      if(lot<minlot) lot = minlot;
      if(lot>maxlot) lot = maxlot;
      return(lot);
    } 
}